/************************************************************************
File Name:	Invsqrt_test.asm

Date Modified:	05/22/00		GJO
				05/25/00		GJO	Code verified on rev 0.1
				09/19/04		JDT Ported to VDSP++ 3.5. replace .SECTION syntax

Purpose:	ADSP-21364 multichannel SIMD program to call 
			invsqrt.asm and perform inverse square root using 
			the 1/sqrt(y) approximation.

************************************************************************/

#include    "def21364.h"

#define		N  2

.extern	isqrtsgl;

/* DM data */
.SECTION/dm seg_dmda;
.var	IN_NUM[N]  = 0.543999, 0.334223 ;	/* Data samples */
.var	RSLT[N];			/* Results */


/* PM data */
.SECTION/pm seg_pmda;


/* PM interrupt vector code */
.SECTION/pm   seg_rth;
Reserved_1:     rti; nop; nop; nop;
Chip_Reset:     idle; jump start; nop; nop;


/* Program memory code */
.SECTION/pm seg_pmco;
start:						/* Starting location */
	m1 = 2;				/* Set up address increment registers */
	l0 = 0;				/* Initialize modulo addressing control registers */
	l1 = 0;
	call isqrtsgl (db); 	/* Call inverse sqrt() function */
	b0 = IN_NUM;		/* Initialize pointers */
	b1 = RSLT;
wait1:   idle;			/* Terminate and wait */

